

from core.himesis import Himesis, HimesisPreConditionPattern
import cPickle as pickle
from uuid import UUID

class HConnectIntersectionsNAC2Bridge(HimesisPreConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HConnectIntersectionsNAC2Bridge.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HConnectIntersectionsNAC2Bridge, self).__init__(name='HConnectIntersectionsNAC2Bridge', num_nodes=2, edges=[])
        
        # Add the edges
        self.add_edges([])
        # Set the graph attributes
        self["GUID__"] = UUID('f8f49841-7d9f-4204-af8f-1a35151f958d')
        
        # Set the node attributes
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["mm__"] = """MT_pre__Intersection"""
        self.vs[0]["MT_label__"] = """2"""
        self.vs[0]["MT_pre__x"] = """from HConnectIntersectionsLHS import HConnectIntersectionsLHS
from HConnectIntersectionsNAC2 import HConnectIntersectionsNAC2
lhs = HConnectIntersectionsLHS()
return HConnectIntersectionsLHS().eval_x2(attr_value, this) and HConnectIntersectionsNAC2(lhs).eval_x2(attr_value, this)"""
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_pre__y"] = """from HConnectIntersectionsLHS import HConnectIntersectionsLHS
from HConnectIntersectionsNAC2 import HConnectIntersectionsNAC2
lhs = HConnectIntersectionsLHS()
return HConnectIntersectionsLHS().eval_y2(attr_value, this) and HConnectIntersectionsNAC2(lhs).eval_y2(attr_value, this)"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('722088f2-7422-4f5f-8d13-1aafaa423644')
        self.vs[1]["MT_subtypeMatching__"] = False
        self.vs[1]["mm__"] = """MT_pre__Intersection"""
        self.vs[1]["MT_label__"] = """3"""
        self.vs[1]["MT_pre__x"] = """from HConnectIntersectionsLHS import HConnectIntersectionsLHS
from HConnectIntersectionsNAC2 import HConnectIntersectionsNAC2
lhs = HConnectIntersectionsLHS()
return HConnectIntersectionsLHS().eval_x3(attr_value, this) and HConnectIntersectionsNAC2(lhs).eval_x3(attr_value, this)"""
        self.vs[1]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[1]["MT_pre__y"] = """from HConnectIntersectionsLHS import HConnectIntersectionsLHS
from HConnectIntersectionsNAC2 import HConnectIntersectionsNAC2
lhs = HConnectIntersectionsLHS()
return HConnectIntersectionsLHS().eval_y3(attr_value, this) and HConnectIntersectionsNAC2(lhs).eval_y3(attr_value, this)"""
        self.vs[1]["MT_dirty__"] = False
        self.vs[1]["GUID__"] = UUID('fc45ad1d-a1f6-4b60-992a-8ca1e06822b3')

    def eval_x2(self, attr_value, this):
        from HConnectIntersectionsLHS import HConnectIntersectionsLHS
        from HConnectIntersectionsNAC2 import HConnectIntersectionsNAC2
        lhs = HConnectIntersectionsLHS()
        return HConnectIntersectionsLHS().eval_x2(attr_value, this) and HConnectIntersectionsNAC2(lhs).eval_x2(attr_value, this)


    def eval_y2(self, attr_value, this):
        from HConnectIntersectionsLHS import HConnectIntersectionsLHS
        from HConnectIntersectionsNAC2 import HConnectIntersectionsNAC2
        lhs = HConnectIntersectionsLHS()
        return HConnectIntersectionsLHS().eval_y2(attr_value, this) and HConnectIntersectionsNAC2(lhs).eval_y2(attr_value, this)


    def eval_x3(self, attr_value, this):
        from HConnectIntersectionsLHS import HConnectIntersectionsLHS
        from HConnectIntersectionsNAC2 import HConnectIntersectionsNAC2
        lhs = HConnectIntersectionsLHS()
        return HConnectIntersectionsLHS().eval_x3(attr_value, this) and HConnectIntersectionsNAC2(lhs).eval_x3(attr_value, this)


    def eval_y3(self, attr_value, this):
        from HConnectIntersectionsLHS import HConnectIntersectionsLHS
        from HConnectIntersectionsNAC2 import HConnectIntersectionsNAC2
        lhs = HConnectIntersectionsLHS()
        return HConnectIntersectionsLHS().eval_y3(attr_value, this) and HConnectIntersectionsNAC2(lhs).eval_y3(attr_value, this)


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        return True

