

from core.himesis import Himesis, HimesisPreConditionPattern
import cPickle as pickle
from uuid import UUID

class HExpandEastNAC0Bridge(HimesisPreConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HExpandEastNAC0Bridge.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HExpandEastNAC0Bridge, self).__init__(name='HExpandEastNAC0Bridge', num_nodes=1, edges=[])
        
        # Add the edges
        self.add_edges([])
        # Set the graph attributes
        self["GUID__"] = UUID('a1b751cf-32b0-414a-973f-d2acfcf5c682')
        
        # Set the node attributes
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["mm__"] = """MT_pre__Intersection"""
        self.vs[0]["MT_label__"] = """2"""
        self.vs[0]["MT_pre__x"] = """from HExpandEastNAC0 import HExpandEastNAC0
from HExpandEastLHS import HExpandEastLHS
lhs = HExpandEastLHS()
return HExpandEastNAC0(lhs).eval_x2(attr_value, this) and HExpandEastLHS().eval_x2(attr_value, this)"""
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_pre__y"] = """from HExpandEastNAC0 import HExpandEastNAC0
from HExpandEastLHS import HExpandEastLHS
lhs = HExpandEastLHS()
return HExpandEastNAC0(lhs).eval_y2(attr_value, this) and HExpandEastLHS().eval_y2(attr_value, this)"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('23f27a11-7059-4d99-9569-5dd7ff5946f1')

    def eval_x2(self, attr_value, this):
        from HExpandEastNAC0 import HExpandEastNAC0
        from HExpandEastLHS import HExpandEastLHS
        lhs = HExpandEastLHS()
        return HExpandEastNAC0(lhs).eval_x2(attr_value, this) and HExpandEastLHS().eval_x2(attr_value, this)


    def eval_y2(self, attr_value, this):
        from HExpandEastNAC0 import HExpandEastNAC0
        from HExpandEastLHS import HExpandEastLHS
        lhs = HExpandEastLHS()
        return HExpandEastNAC0(lhs).eval_y2(attr_value, this) and HExpandEastLHS().eval_y2(attr_value, this)


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        return True

