

from core.himesis import Himesis, HimesisPreConditionPattern
import cPickle as pickle
from uuid import UUID

class HExpandNorthNAC0Bridge(HimesisPreConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HExpandNorthNAC0Bridge.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HExpandNorthNAC0Bridge, self).__init__(name='HExpandNorthNAC0Bridge', num_nodes=1, edges=[])
        
        # Add the edges
        self.add_edges([])
        # Set the graph attributes
        self["GUID__"] = UUID('d9b7d8d2-454f-4c07-b957-162c2f25f107')
        
        # Set the node attributes
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["mm__"] = """MT_pre__Intersection"""
        self.vs[0]["MT_label__"] = """2"""
        self.vs[0]["MT_pre__x"] = """from HExpandNorthNAC0 import HExpandNorthNAC0
from HExpandNorthLHS import HExpandNorthLHS
lhs = HExpandNorthLHS()
return HExpandNorthNAC0(lhs).eval_x2(attr_value, this) and HExpandNorthLHS().eval_x2(attr_value, this)"""
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_pre__y"] = """from HExpandNorthNAC0 import HExpandNorthNAC0
from HExpandNorthLHS import HExpandNorthLHS
lhs = HExpandNorthLHS()
return HExpandNorthNAC0(lhs).eval_y2(attr_value, this) and HExpandNorthLHS().eval_y2(attr_value, this)"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('bb1070c8-dd23-444f-850e-969b5f65e130')

    def eval_x2(self, attr_value, this):
        from HExpandNorthNAC0 import HExpandNorthNAC0
        from HExpandNorthLHS import HExpandNorthLHS
        lhs = HExpandNorthLHS()
        return HExpandNorthNAC0(lhs).eval_x2(attr_value, this) and HExpandNorthLHS().eval_x2(attr_value, this)


    def eval_y2(self, attr_value, this):
        from HExpandNorthNAC0 import HExpandNorthNAC0
        from HExpandNorthLHS import HExpandNorthLHS
        lhs = HExpandNorthLHS()
        return HExpandNorthNAC0(lhs).eval_y2(attr_value, this) and HExpandNorthLHS().eval_y2(attr_value, this)


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        return True

