

from core.himesis import Himesis, HimesisPreConditionPattern
import cPickle as pickle
from uuid import UUID

class HExpandNorthNAC4Bridge(HimesisPreConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HExpandNorthNAC4Bridge.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HExpandNorthNAC4Bridge, self).__init__(name='HExpandNorthNAC4Bridge', num_nodes=1, edges=[])
        
        # Add the edges
        self.add_edges([])
        # Set the graph attributes
        self["GUID__"] = UUID('c118e773-dfa0-4438-969c-804928051210')
        
        # Set the node attributes
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["mm__"] = """MT_pre__Intersection"""
        self.vs[0]["MT_label__"] = """2"""
        self.vs[0]["MT_pre__x"] = """from HExpandNorthLHS import HExpandNorthLHS
from HExpandNorthNAC4 import HExpandNorthNAC4
lhs = HExpandNorthLHS()
return HExpandNorthLHS().eval_x2(attr_value, this) and HExpandNorthNAC4(lhs).eval_x2(attr_value, this)"""
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_pre__y"] = """from HExpandNorthLHS import HExpandNorthLHS
from HExpandNorthNAC4 import HExpandNorthNAC4
lhs = HExpandNorthLHS()
return HExpandNorthLHS().eval_y2(attr_value, this) and HExpandNorthNAC4(lhs).eval_y2(attr_value, this)"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('afd9f8cd-69d2-40f7-bb5e-fb3795290200')

    def eval_x2(self, attr_value, this):
        from HExpandNorthLHS import HExpandNorthLHS
        from HExpandNorthNAC4 import HExpandNorthNAC4
        lhs = HExpandNorthLHS()
        return HExpandNorthLHS().eval_x2(attr_value, this) and HExpandNorthNAC4(lhs).eval_x2(attr_value, this)


    def eval_y2(self, attr_value, this):
        from HExpandNorthLHS import HExpandNorthLHS
        from HExpandNorthNAC4 import HExpandNorthNAC4
        lhs = HExpandNorthLHS()
        return HExpandNorthLHS().eval_y2(attr_value, this) and HExpandNorthNAC4(lhs).eval_y2(attr_value, this)


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        return True

