

from core.himesis import Himesis, HimesisPostConditionPattern
import cPickle as pickle
from uuid import UUID

class HExpandNorthRHS(HimesisPostConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HExpandNorthRHS.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HExpandNorthRHS, self).__init__(name='HExpandNorthRHS', num_nodes=8, edges=[])
        
        # Add the edges
        self.add_edges([(6, 2), (2, 0), (7, 3), (3, 0), (0, 4), (4, 6), (0, 5), (5, 7)])
        # Set the graph attributes
        self["mm__"] = pickle.loads("""(lp1
S'MT_post__Map'
p2
aS'MoTifRule'
p3
a.""")
        self["MT_action__"] = """#===============================================================================
# This code is executed after the rule has been applied.
# You can access a node labelled n matched by this rule by: PostNode('n').
# To access attribute x of node n, use: PostNode('n')['x'].
#===============================================================================

pass
"""
        self["name"] = """"""
        self["GUID__"] = UUID('ab393b72-8939-4605-989e-a651b8ed897c')
        
        # Set the node attributes
        self.vs[0]["MT_label__"] = """4"""
        self.vs[0]["MT_post__length"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return 5
"""
        self.vs[0]["mm__"] = """MT_post__Road"""
        self.vs[0]["GUID__"] = UUID('cb489501-5abe-4c91-8713-e3cf87cee4b9')
        self.vs[1]["MT_post__remaining"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return attr_value - 12
"""
        self.vs[1]["MT_label__"] = """1"""
        self.vs[1]["mm__"] = """MT_post__MapInformation"""
        self.vs[1]["MT_post__size"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return attr_value
"""
        self.vs[1]["GUID__"] = UUID('aa01f3e4-a724-42c7-a509-469c1e89a0fc')
        self.vs[2]["MT_label__"] = """5"""
        self.vs[2]["mm__"] = """MT_post__FromIntersection"""
        self.vs[2]["GUID__"] = UUID('d7e4591b-d099-4380-8e81-4ab1cfe428bf')
        self.vs[3]["MT_label__"] = """8"""
        self.vs[3]["mm__"] = """MT_post__FromIntersection"""
        self.vs[3]["GUID__"] = UUID('e8440d66-acec-44b2-8d12-57aa3c27e75b')
        self.vs[4]["MT_label__"] = """6"""
        self.vs[4]["mm__"] = """MT_post__ToIntersection"""
        self.vs[4]["GUID__"] = UUID('b7b99e17-b19e-4611-9f69-9b3bf7fc90dc')
        self.vs[5]["MT_label__"] = """7"""
        self.vs[5]["mm__"] = """MT_post__ToIntersection"""
        self.vs[5]["GUID__"] = UUID('716c7db1-9bb6-427b-b3b2-cc48a00d582e')
        self.vs[6]["MT_label__"] = """2"""
        self.vs[6]["MT_post__x"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return attr_value
"""
        self.vs[6]["mm__"] = """MT_post__Intersection"""
        self.vs[6]["MT_post__y"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return attr_value
"""
        self.vs[6]["GUID__"] = UUID('34795f67-6205-4b7e-9042-c1c981f9871c')
        self.vs[7]["MT_label__"] = """3"""
        self.vs[7]["MT_post__x"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return PreNode('2')['x']
"""
        self.vs[7]["mm__"] = """MT_post__Intersection"""
        self.vs[7]["MT_post__y"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return PreNode('2')['y'] - 12
"""
        self.vs[7]["GUID__"] = UUID('86bcbb45-ee63-46f8-8fe6-1e93606f9b5a')

        from HExpandNorthLHS import HExpandNorthLHS
        self.pre = HExpandNorthLHS()
    
    def set_x3(self, attr_value, PreNode, graph):
        
        #===============================================================================
        # You can access the value of the current node's attribute value by: attr_value.
        # If the current node shall be created you MUST initialize it here!
        # You can access a node labelled n by: PreNode('n').
        # To access attribute x of node n, use: PreNode('n')['x'].
        # Note that the attribute values are those before the match is rewritten.
        # The order in which this code is executed depends on the label value
        # of the encapsulating node.
        # The given action must return the new value of the attribute.
        #===============================================================================
        
        return PreNode('2')['x']


    def set_y3(self, attr_value, PreNode, graph):
        
        #===============================================================================
        # You can access the value of the current node's attribute value by: attr_value.
        # If the current node shall be created you MUST initialize it here!
        # You can access a node labelled n by: PreNode('n').
        # To access attribute x of node n, use: PreNode('n')['x'].
        # Note that the attribute values are those before the match is rewritten.
        # The order in which this code is executed depends on the label value
        # of the encapsulating node.
        # The given action must return the new value of the attribute.
        #===============================================================================
        
        return PreNode('2')['y'] - 12


    def set_length4(self, attr_value, PreNode, graph):
        
        #===============================================================================
        # You can access the value of the current node's attribute value by: attr_value.
        # If the current node shall be created you MUST initialize it here!
        # You can access a node labelled n by: PreNode('n').
        # To access attribute x of node n, use: PreNode('n')['x'].
        # Note that the attribute values are those before the match is rewritten.
        # The order in which this code is executed depends on the label value
        # of the encapsulating node.
        # The given action must return the new value of the attribute.
        #===============================================================================
        
        return 5


    def set_remaining1(self, attr_value, PreNode, graph):
        
        #===============================================================================
        # You can access the value of the current node's attribute value by: attr_value.
        # If the current node shall be created you MUST initialize it here!
        # You can access a node labelled n by: PreNode('n').
        # To access attribute x of node n, use: PreNode('n')['x'].
        # Note that the attribute values are those before the match is rewritten.
        # The order in which this code is executed depends on the label value
        # of the encapsulating node.
        # The given action must return the new value of the attribute.
        #===============================================================================
        
        return attr_value - 12


    def action(self, PostNode, graph):
        """
            Executable constraint code. 
            @param PostNode: Function taking an integer as parameter
                             and returns the node corresponding to that label.
        """
        #===============================================================================
        # This code is executed after the rule has been applied.
        # You can access a node labelled n matched by this rule by: PostNode('n').
        # To access attribute x of node n, use: PostNode('n')['x'].
        #===============================================================================
        
        pass

    def execute(self, packet, match):
        """
            Transforms the current match of the packet according to the rule %s.
            Pivots are also assigned, if any.
            @param packet: The input packet.
            @param match: The match to rewrite.
        """
        graph = packet.graph
        
        # Build a dictionary {label: node index} mapping each label of the pattern to a node in the graph to rewrite.
        # Because of the uniqueness property of labels in a rule, we can store all LHS labels
        # and subsequently add the labels corresponding to the nodes to be created.
        labels = match.copy()
        
        #===============================================================================
        # Update attribute values
        #===============================================================================
        # MapInformation1
        try:
            graph.vs[labels['1']]['remaining'] = self.set_remaining1(graph.vs[labels['1']]['remaining'], lambda i: graph.vs[match[i]], graph)
        except Exception, e:
            raise Exception('An error has occurred while computing the value of the attribute \'remaining\'', e)
        
        graph.vs[labels['1']][Himesis.Constants.MT_DIRTY] = True
        
        #===============================================================================
        # Create new nodes
        #===============================================================================
        # FromIntersection5
        new_node = graph.add_node()
        labels['5'] = new_node
        graph.vs[new_node][Himesis.Constants.META_MODEL] = 'FromIntersection'
        # FromIntersection8
        new_node = graph.add_node()
        labels['8'] = new_node
        graph.vs[new_node][Himesis.Constants.META_MODEL] = 'FromIntersection'
        # ToIntersection6
        new_node = graph.add_node()
        labels['6'] = new_node
        graph.vs[new_node][Himesis.Constants.META_MODEL] = 'ToIntersection'
        # ToIntersection7
        new_node = graph.add_node()
        labels['7'] = new_node
        graph.vs[new_node][Himesis.Constants.META_MODEL] = 'ToIntersection'
        # Intersection3
        new_node = graph.add_node()
        labels['3'] = new_node
        graph.vs[new_node][Himesis.Constants.META_MODEL] = 'Intersection'
        try:
            graph.vs[new_node]['x'] = self.set_x3(None, lambda i: graph.vs[match[i]], graph)
        except Exception, e:
            raise Exception('An error has occurred while computing the value of the attribute \'x\'', e)
        try:
            graph.vs[new_node]['y'] = self.set_y3(None, lambda i: graph.vs[match[i]], graph)
        except Exception, e:
            raise Exception('An error has occurred while computing the value of the attribute \'y\'', e)
        # Road4
        new_node = graph.add_node()
        labels['4'] = new_node
        graph.vs[new_node][Himesis.Constants.META_MODEL] = 'Road'
        try:
            graph.vs[new_node]['length'] = self.set_length4(None, lambda i: graph.vs[match[i]], graph)
        except Exception, e:
            raise Exception('An error has occurred while computing the value of the attribute \'length\'', e)
        
        #===============================================================================
        # Create new edges
        #===============================================================================
        # Intersection3 -> FromIntersection8
        graph.add_edges((labels['3'], labels['8']))
        # ToIntersection7 -> Intersection3
        graph.add_edges((labels['7'], labels['3']))
        # FromIntersection5 -> Road4
        graph.add_edges((labels['5'], labels['4']))
        # FromIntersection8 -> Road4
        graph.add_edges((labels['8'], labels['4']))
        # Road4 -> ToIntersection6
        graph.add_edges((labels['4'], labels['6']))
        # Road4 -> ToIntersection7
        graph.add_edges((labels['4'], labels['7']))
        # Intersection2 -> FromIntersection5
        graph.add_edges((labels['2'], labels['5']))
        # ToIntersection6 -> Intersection2
        graph.add_edges((labels['6'], labels['2']))
        
        #===============================================================================
        # Set the output pivots
        #===============================================================================
        
        #===============================================================================
        # Perform the post-action
        #===============================================================================
        try:
            self.action(lambda i: graph.vs[labels[i]], graph)
        except Exception, e:
            raise Exception('An error has occurred while applying the post-action', e)
        #===============================================================================
        # Finally, delete nodes (this will automatically delete the adjacent edges)
        #===============================================================================
    
