

from core.himesis import Himesis, HimesisPreConditionPattern
import cPickle as pickle
from uuid import UUID

class HExpandSouthNAC0Bridge(HimesisPreConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HExpandSouthNAC0Bridge.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HExpandSouthNAC0Bridge, self).__init__(name='HExpandSouthNAC0Bridge', num_nodes=1, edges=[])
        
        # Add the edges
        self.add_edges([])
        # Set the graph attributes
        self["GUID__"] = UUID('a34f060f-37aa-41a6-9031-0d1463c3610a')
        
        # Set the node attributes
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["mm__"] = """MT_pre__Intersection"""
        self.vs[0]["MT_label__"] = """2"""
        self.vs[0]["MT_pre__x"] = """from HExpandSouthNAC0 import HExpandSouthNAC0
from HExpandSouthLHS import HExpandSouthLHS
lhs = HExpandSouthLHS()
return HExpandSouthNAC0(lhs).eval_x2(attr_value, this) and HExpandSouthLHS().eval_x2(attr_value, this)"""
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_pre__y"] = """from HExpandSouthNAC0 import HExpandSouthNAC0
from HExpandSouthLHS import HExpandSouthLHS
lhs = HExpandSouthLHS()
return HExpandSouthNAC0(lhs).eval_y2(attr_value, this) and HExpandSouthLHS().eval_y2(attr_value, this)"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('4fcc1d4d-56ca-4c4c-a2b9-a34ca961beb6')

    def eval_x2(self, attr_value, this):
        from HExpandSouthNAC0 import HExpandSouthNAC0
        from HExpandSouthLHS import HExpandSouthLHS
        lhs = HExpandSouthLHS()
        return HExpandSouthNAC0(lhs).eval_x2(attr_value, this) and HExpandSouthLHS().eval_x2(attr_value, this)


    def eval_y2(self, attr_value, this):
        from HExpandSouthNAC0 import HExpandSouthNAC0
        from HExpandSouthLHS import HExpandSouthLHS
        lhs = HExpandSouthLHS()
        return HExpandSouthNAC0(lhs).eval_y2(attr_value, this) and HExpandSouthLHS().eval_y2(attr_value, this)


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        return True

