

from core.himesis import Himesis, HimesisPreConditionPattern
import cPickle as pickle
from uuid import UUID

class HExpandSouthNAC2Bridge(HimesisPreConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HExpandSouthNAC2Bridge.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HExpandSouthNAC2Bridge, self).__init__(name='HExpandSouthNAC2Bridge', num_nodes=1, edges=[])
        
        # Add the edges
        self.add_edges([])
        # Set the graph attributes
        self["GUID__"] = UUID('dba79619-877a-4bd7-b05f-9c6009df8964')
        
        # Set the node attributes
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["mm__"] = """MT_pre__Intersection"""
        self.vs[0]["MT_label__"] = """2"""
        self.vs[0]["MT_pre__x"] = """from HExpandSouthLHS import HExpandSouthLHS
from HExpandSouthNAC2 import HExpandSouthNAC2
lhs = HExpandSouthLHS()
return HExpandSouthLHS().eval_x2(attr_value, this) and HExpandSouthNAC2(lhs).eval_x2(attr_value, this)"""
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_pre__y"] = """from HExpandSouthLHS import HExpandSouthLHS
from HExpandSouthNAC2 import HExpandSouthNAC2
lhs = HExpandSouthLHS()
return HExpandSouthLHS().eval_y2(attr_value, this) and HExpandSouthNAC2(lhs).eval_y2(attr_value, this)"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('5575622e-f78a-48f7-8831-e121aa942fa5')

    def eval_x2(self, attr_value, this):
        from HExpandSouthLHS import HExpandSouthLHS
        from HExpandSouthNAC2 import HExpandSouthNAC2
        lhs = HExpandSouthLHS()
        return HExpandSouthLHS().eval_x2(attr_value, this) and HExpandSouthNAC2(lhs).eval_x2(attr_value, this)


    def eval_y2(self, attr_value, this):
        from HExpandSouthLHS import HExpandSouthLHS
        from HExpandSouthNAC2 import HExpandSouthNAC2
        lhs = HExpandSouthLHS()
        return HExpandSouthLHS().eval_y2(attr_value, this) and HExpandSouthNAC2(lhs).eval_y2(attr_value, this)


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        return True

