

from core.himesis import Himesis, HimesisPreConditionPattern
import cPickle as pickle
from uuid import UUID

class HExpandWestNAC0Bridge(HimesisPreConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HExpandWestNAC0Bridge.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HExpandWestNAC0Bridge, self).__init__(name='HExpandWestNAC0Bridge', num_nodes=1, edges=[])
        
        # Add the edges
        self.add_edges([])
        # Set the graph attributes
        self["GUID__"] = UUID('59a2bd95-c993-45cc-92e5-882782aa1424')
        
        # Set the node attributes
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["mm__"] = """MT_pre__Intersection"""
        self.vs[0]["MT_label__"] = """2"""
        self.vs[0]["MT_pre__x"] = """from HExpandWestNAC0 import HExpandWestNAC0
from HExpandWestLHS import HExpandWestLHS
lhs = HExpandWestLHS()
return HExpandWestNAC0(lhs).eval_x2(attr_value, this) and HExpandWestLHS().eval_x2(attr_value, this)"""
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_pre__y"] = """from HExpandWestNAC0 import HExpandWestNAC0
from HExpandWestLHS import HExpandWestLHS
lhs = HExpandWestLHS()
return HExpandWestNAC0(lhs).eval_y2(attr_value, this) and HExpandWestLHS().eval_y2(attr_value, this)"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('b7edd93d-e3e9-41b1-bed0-7e40689d7675')

    def eval_x2(self, attr_value, this):
        from HExpandWestNAC0 import HExpandWestNAC0
        from HExpandWestLHS import HExpandWestLHS
        lhs = HExpandWestLHS()
        return HExpandWestNAC0(lhs).eval_x2(attr_value, this) and HExpandWestLHS().eval_x2(attr_value, this)


    def eval_y2(self, attr_value, this):
        from HExpandWestNAC0 import HExpandWestNAC0
        from HExpandWestLHS import HExpandWestLHS
        lhs = HExpandWestLHS()
        return HExpandWestNAC0(lhs).eval_y2(attr_value, this) and HExpandWestLHS().eval_y2(attr_value, this)


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        return True

