

from core.himesis import Himesis, HimesisPreConditionPattern
import cPickle as pickle
from uuid import UUID

class HGrowRoadNAC0Bridge(HimesisPreConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HGrowRoadNAC0Bridge.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HGrowRoadNAC0Bridge, self).__init__(name='HGrowRoadNAC0Bridge', num_nodes=1, edges=[])
        
        # Add the edges
        self.add_edges([])
        # Set the graph attributes
        self["GUID__"] = UUID('f4f17c23-3c64-4e89-beb9-335d15bf375f')
        
        # Set the node attributes
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["mm__"] = """MT_pre__Intersection"""
        self.vs[0]["MT_label__"] = """4"""
        self.vs[0]["MT_pre__x"] = """from HGrowRoadNAC0 import HGrowRoadNAC0
from HGrowRoadLHS import HGrowRoadLHS
lhs = HGrowRoadLHS()
return HGrowRoadNAC0(lhs).eval_x4(attr_value, this) and HGrowRoadLHS().eval_x4(attr_value, this)"""
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_pre__y"] = """from HGrowRoadNAC0 import HGrowRoadNAC0
from HGrowRoadLHS import HGrowRoadLHS
lhs = HGrowRoadLHS()
return HGrowRoadNAC0(lhs).eval_y4(attr_value, this) and HGrowRoadLHS().eval_y4(attr_value, this)"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('1c8982cc-8794-4a4e-b65a-6eebfd5f9bfb')

    def eval_x4(self, attr_value, this):
        from HGrowRoadNAC0 import HGrowRoadNAC0
        from HGrowRoadLHS import HGrowRoadLHS
        lhs = HGrowRoadLHS()
        return HGrowRoadNAC0(lhs).eval_x4(attr_value, this) and HGrowRoadLHS().eval_x4(attr_value, this)


    def eval_y4(self, attr_value, this):
        from HGrowRoadNAC0 import HGrowRoadNAC0
        from HGrowRoadLHS import HGrowRoadLHS
        lhs = HGrowRoadLHS()
        return HGrowRoadNAC0(lhs).eval_y4(attr_value, this) and HGrowRoadLHS().eval_y4(attr_value, this)


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        return True

