

from core.himesis import Himesis, HimesisPreConditionPattern
import cPickle as pickle
from uuid import UUID

class HConnectIntersectionsNAC0Bridge(HimesisPreConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HConnectIntersectionsNAC0Bridge.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HConnectIntersectionsNAC0Bridge, self).__init__(name='HConnectIntersectionsNAC0Bridge', num_nodes=2, edges=[])
        
        # Add the edges
        self.add_edges([])
        # Set the graph attributes
        self["GUID__"] = UUID('e538cf74-9237-48b1-8fae-3a049ba91bc6')
        
        # Set the node attributes
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["mm__"] = """MT_pre__Intersection"""
        self.vs[0]["MT_label__"] = """2"""
        self.vs[0]["MT_pre__x"] = """from HConnectIntersectionsNAC0 import HConnectIntersectionsNAC0
from HConnectIntersectionsLHS import HConnectIntersectionsLHS
lhs = HConnectIntersectionsLHS()
return HConnectIntersectionsNAC0(lhs).eval_x2(attr_value, this) and HConnectIntersectionsLHS().eval_x2(attr_value, this)"""
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_pre__y"] = """from HConnectIntersectionsNAC0 import HConnectIntersectionsNAC0
from HConnectIntersectionsLHS import HConnectIntersectionsLHS
lhs = HConnectIntersectionsLHS()
return HConnectIntersectionsNAC0(lhs).eval_y2(attr_value, this) and HConnectIntersectionsLHS().eval_y2(attr_value, this)"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('e0d2f974-1ac0-48ad-b593-4d709d290d4e')
        self.vs[1]["MT_subtypeMatching__"] = False
        self.vs[1]["mm__"] = """MT_pre__Intersection"""
        self.vs[1]["MT_label__"] = """3"""
        self.vs[1]["MT_pre__x"] = """from HConnectIntersectionsNAC0 import HConnectIntersectionsNAC0
from HConnectIntersectionsLHS import HConnectIntersectionsLHS
lhs = HConnectIntersectionsLHS()
return HConnectIntersectionsNAC0(lhs).eval_x3(attr_value, this) and HConnectIntersectionsLHS().eval_x3(attr_value, this)"""
        self.vs[1]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[1]["MT_pre__y"] = """from HConnectIntersectionsNAC0 import HConnectIntersectionsNAC0
from HConnectIntersectionsLHS import HConnectIntersectionsLHS
lhs = HConnectIntersectionsLHS()
return HConnectIntersectionsNAC0(lhs).eval_y3(attr_value, this) and HConnectIntersectionsLHS().eval_y3(attr_value, this)"""
        self.vs[1]["MT_dirty__"] = False
        self.vs[1]["GUID__"] = UUID('e3c522a2-40a5-416e-a1cb-6b94f51dad8a')

    def eval_x2(self, attr_value, this):
        from HConnectIntersectionsNAC0 import HConnectIntersectionsNAC0
        from HConnectIntersectionsLHS import HConnectIntersectionsLHS
        lhs = HConnectIntersectionsLHS()
        return HConnectIntersectionsNAC0(lhs).eval_x2(attr_value, this) and HConnectIntersectionsLHS().eval_x2(attr_value, this)


    def eval_y2(self, attr_value, this):
        from HConnectIntersectionsNAC0 import HConnectIntersectionsNAC0
        from HConnectIntersectionsLHS import HConnectIntersectionsLHS
        lhs = HConnectIntersectionsLHS()
        return HConnectIntersectionsNAC0(lhs).eval_y2(attr_value, this) and HConnectIntersectionsLHS().eval_y2(attr_value, this)


    def eval_x3(self, attr_value, this):
        from HConnectIntersectionsNAC0 import HConnectIntersectionsNAC0
        from HConnectIntersectionsLHS import HConnectIntersectionsLHS
        lhs = HConnectIntersectionsLHS()
        return HConnectIntersectionsNAC0(lhs).eval_x3(attr_value, this) and HConnectIntersectionsLHS().eval_x3(attr_value, this)


    def eval_y3(self, attr_value, this):
        from HConnectIntersectionsNAC0 import HConnectIntersectionsNAC0
        from HConnectIntersectionsLHS import HConnectIntersectionsLHS
        lhs = HConnectIntersectionsLHS()
        return HConnectIntersectionsNAC0(lhs).eval_y3(attr_value, this) and HConnectIntersectionsLHS().eval_y3(attr_value, this)


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        return True

