

from core.himesis import Himesis, HimesisPostConditionPattern
import cPickle as pickle
from uuid import UUID

class HConnectIntersectionsRHS(HimesisPostConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HConnectIntersectionsRHS.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HConnectIntersectionsRHS, self).__init__(name='HConnectIntersectionsRHS', num_nodes=8, edges=[])
        
        # Add the edges
        self.add_edges([(7, 2), (2, 0), (6, 3), (3, 0), (0, 4), (4, 7), (0, 5), (5, 6)])
        # Set the graph attributes
        self["mm__"] = pickle.loads("""(lp1
S'MT_post__Map'
p2
aS'MoTifRule'
p3
a.""")
        self["MT_action__"] = """#===============================================================================
# This code is executed after the rule has been applied.
# You can access a node labelled n matched by this rule by: PostNode('n').
# To access attribute x of node n, use: PostNode('n')['x'].
#===============================================================================

pass
"""
        self["name"] = """"""
        self["GUID__"] = UUID('f40643d2-f305-4e89-954e-059fff30eb79')
        
        # Set the node attributes
        self.vs[0]["MT_label__"] = """4"""
        self.vs[0]["MT_post__length"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

x = abs(PreNode('2')['x'] - PreNode('3')['x']) - 7
y = abs(PreNode('2')['y'] - PreNode('3')['y']) - 7

return max(x, y)
"""
        self.vs[0]["mm__"] = """MT_post__Road"""
        self.vs[0]["GUID__"] = UUID('d83e8af3-5b51-4479-9cc3-6d4101f7df5d')
        self.vs[1]["MT_post__remaining"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return attr_value
"""
        self.vs[1]["MT_label__"] = """1"""
        self.vs[1]["mm__"] = """MT_post__MapInformation"""
        self.vs[1]["MT_post__size"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return attr_value
"""
        self.vs[1]["GUID__"] = UUID('aa31b9f5-6818-44d8-892a-258787830b1a')
        self.vs[2]["MT_label__"] = """6"""
        self.vs[2]["mm__"] = """MT_post__FromIntersection"""
        self.vs[2]["GUID__"] = UUID('aed1d986-006e-4c13-b8bc-8203314faeb3')
        self.vs[3]["MT_label__"] = """8"""
        self.vs[3]["mm__"] = """MT_post__FromIntersection"""
        self.vs[3]["GUID__"] = UUID('11bdc543-27f4-4af1-a796-9783611cc8cf')
        self.vs[4]["MT_label__"] = """5"""
        self.vs[4]["mm__"] = """MT_post__ToIntersection"""
        self.vs[4]["GUID__"] = UUID('e7cf2907-18c1-42a3-9543-9d3311bfa83b')
        self.vs[5]["MT_label__"] = """7"""
        self.vs[5]["mm__"] = """MT_post__ToIntersection"""
        self.vs[5]["GUID__"] = UUID('55a46968-fee7-4b97-9901-be22cf514f39')
        self.vs[6]["MT_label__"] = """2"""
        self.vs[6]["MT_post__x"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return attr_value
"""
        self.vs[6]["mm__"] = """MT_post__Intersection"""
        self.vs[6]["MT_post__y"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return attr_value
"""
        self.vs[6]["GUID__"] = UUID('23a5081d-1433-4bf8-a173-93c991aa6552')
        self.vs[7]["MT_label__"] = """3"""
        self.vs[7]["MT_post__x"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return attr_value
"""
        self.vs[7]["mm__"] = """MT_post__Intersection"""
        self.vs[7]["MT_post__y"] = """
#===============================================================================
# You can access the value of the current node's attribute value by: attr_value.
# If the current node shall be created you MUST initialize it here!
# You can access a node labelled n by: PreNode('n').
# To access attribute x of node n, use: PreNode('n')['x'].
# Note that the attribute values are those before the match is rewritten.
# The order in which this code is executed depends on the label value
# of the encapsulating node.
# The given action must return the new value of the attribute.
#===============================================================================

return attr_value
"""
        self.vs[7]["GUID__"] = UUID('0357c230-6fb9-484f-b17c-3d54a763c100')

        from HConnectIntersectionsLHS import HConnectIntersectionsLHS
        self.pre = HConnectIntersectionsLHS()
    
    def set_length4(self, attr_value, PreNode, graph):
        
        #===============================================================================
        # You can access the value of the current node's attribute value by: attr_value.
        # If the current node shall be created you MUST initialize it here!
        # You can access a node labelled n by: PreNode('n').
        # To access attribute x of node n, use: PreNode('n')['x'].
        # Note that the attribute values are those before the match is rewritten.
        # The order in which this code is executed depends on the label value
        # of the encapsulating node.
        # The given action must return the new value of the attribute.
        #===============================================================================
        
        x = abs(PreNode('2')['x'] - PreNode('3')['x']) - 7
        y = abs(PreNode('2')['y'] - PreNode('3')['y']) - 7
        
        return max(x, y)


    def action(self, PostNode, graph):
        """
            Executable constraint code. 
            @param PostNode: Function taking an integer as parameter
                             and returns the node corresponding to that label.
        """
        #===============================================================================
        # This code is executed after the rule has been applied.
        # You can access a node labelled n matched by this rule by: PostNode('n').
        # To access attribute x of node n, use: PostNode('n')['x'].
        #===============================================================================
        
        pass

    def execute(self, packet, match):
        """
            Transforms the current match of the packet according to the rule %s.
            Pivots are also assigned, if any.
            @param packet: The input packet.
            @param match: The match to rewrite.
        """
        graph = packet.graph
        
        # Build a dictionary {label: node index} mapping each label of the pattern to a node in the graph to rewrite.
        # Because of the uniqueness property of labels in a rule, we can store all LHS labels
        # and subsequently add the labels corresponding to the nodes to be created.
        labels = match.copy()
        
        #===============================================================================
        # Update attribute values
        #===============================================================================
        
        #===============================================================================
        # Create new nodes
        #===============================================================================
        # FromIntersection6
        new_node = graph.add_node()
        labels['6'] = new_node
        graph.vs[new_node][Himesis.Constants.META_MODEL] = 'FromIntersection'
        # FromIntersection8
        new_node = graph.add_node()
        labels['8'] = new_node
        graph.vs[new_node][Himesis.Constants.META_MODEL] = 'FromIntersection'
        # ToIntersection5
        new_node = graph.add_node()
        labels['5'] = new_node
        graph.vs[new_node][Himesis.Constants.META_MODEL] = 'ToIntersection'
        # ToIntersection7
        new_node = graph.add_node()
        labels['7'] = new_node
        graph.vs[new_node][Himesis.Constants.META_MODEL] = 'ToIntersection'
        # Road4
        new_node = graph.add_node()
        labels['4'] = new_node
        graph.vs[new_node][Himesis.Constants.META_MODEL] = 'Road'
        try:
            graph.vs[new_node]['length'] = self.set_length4(None, lambda i: graph.vs[match[i]], graph)
        except Exception, e:
            raise Exception('An error has occurred while computing the value of the attribute \'length\'', e)
        
        #===============================================================================
        # Create new edges
        #===============================================================================
        # FromIntersection6 -> Road4
        graph.add_edges((labels['6'], labels['4']))
        # FromIntersection8 -> Road4
        graph.add_edges((labels['8'], labels['4']))
        # Road4 -> ToIntersection5
        graph.add_edges((labels['4'], labels['5']))
        # Road4 -> ToIntersection7
        graph.add_edges((labels['4'], labels['7']))
        # ToIntersection5 -> Intersection3
        graph.add_edges((labels['5'], labels['3']))
        # Intersection3 -> FromIntersection6
        graph.add_edges((labels['3'], labels['6']))
        # ToIntersection7 -> Intersection2
        graph.add_edges((labels['7'], labels['2']))
        # Intersection2 -> FromIntersection8
        graph.add_edges((labels['2'], labels['8']))
        
        #===============================================================================
        # Set the output pivots
        #===============================================================================
        
        #===============================================================================
        # Perform the post-action
        #===============================================================================
        try:
            self.action(lambda i: graph.vs[labels[i]], graph)
        except Exception, e:
            raise Exception('An error has occurred while applying the post-action', e)
        #===============================================================================
        # Finally, delete nodes (this will automatically delete the adjacent edges)
        #===============================================================================
    
