

from core.himesis import Himesis, HimesisPreConditionPattern
import cPickle as pickle
from uuid import UUID

class HExpandEastNAC3Bridge(HimesisPreConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HExpandEastNAC3Bridge.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HExpandEastNAC3Bridge, self).__init__(name='HExpandEastNAC3Bridge', num_nodes=1, edges=[])
        
        # Add the edges
        self.add_edges([])
        # Set the graph attributes
        self["GUID__"] = UUID('1ba4213c-22e2-48e7-987a-723f014f97a1')
        
        # Set the node attributes
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["mm__"] = """MT_pre__Intersection"""
        self.vs[0]["MT_label__"] = """2"""
        self.vs[0]["MT_pre__x"] = """from HExpandEastLHS import HExpandEastLHS
from HExpandEastNAC3 import HExpandEastNAC3
lhs = HExpandEastLHS()
return HExpandEastLHS().eval_x2(attr_value, this) and HExpandEastNAC3(lhs).eval_x2(attr_value, this)"""
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_pre__y"] = """from HExpandEastLHS import HExpandEastLHS
from HExpandEastNAC3 import HExpandEastNAC3
lhs = HExpandEastLHS()
return HExpandEastLHS().eval_y2(attr_value, this) and HExpandEastNAC3(lhs).eval_y2(attr_value, this)"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('3d593239-21f0-4d20-be9f-f575938eb819')

    def eval_x2(self, attr_value, this):
        from HExpandEastLHS import HExpandEastLHS
        from HExpandEastNAC3 import HExpandEastNAC3
        lhs = HExpandEastLHS()
        return HExpandEastLHS().eval_x2(attr_value, this) and HExpandEastNAC3(lhs).eval_x2(attr_value, this)


    def eval_y2(self, attr_value, this):
        from HExpandEastLHS import HExpandEastLHS
        from HExpandEastNAC3 import HExpandEastNAC3
        lhs = HExpandEastLHS()
        return HExpandEastLHS().eval_y2(attr_value, this) and HExpandEastNAC3(lhs).eval_y2(attr_value, this)


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        return True

