

from core.himesis import Himesis, HimesisPreConditionPattern
import cPickle as pickle
from uuid import UUID

class HExpandWestNAC2Bridge(HimesisPreConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HExpandWestNAC2Bridge.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HExpandWestNAC2Bridge, self).__init__(name='HExpandWestNAC2Bridge', num_nodes=1, edges=[])
        
        # Add the edges
        self.add_edges([])
        # Set the graph attributes
        self["GUID__"] = UUID('9ed5dff1-1f4c-4e38-b868-ae2313564a15')
        
        # Set the node attributes
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["mm__"] = """MT_pre__Intersection"""
        self.vs[0]["MT_label__"] = """2"""
        self.vs[0]["MT_pre__x"] = """from HExpandWestLHS import HExpandWestLHS
from HExpandWestNAC2 import HExpandWestNAC2
lhs = HExpandWestLHS()
return HExpandWestLHS().eval_x2(attr_value, this) and HExpandWestNAC2(lhs).eval_x2(attr_value, this)"""
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_pre__y"] = """from HExpandWestLHS import HExpandWestLHS
from HExpandWestNAC2 import HExpandWestNAC2
lhs = HExpandWestLHS()
return HExpandWestLHS().eval_y2(attr_value, this) and HExpandWestNAC2(lhs).eval_y2(attr_value, this)"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('bc9d7044-e10e-4abf-8d08-42728ae529c2')

    def eval_x2(self, attr_value, this):
        from HExpandWestLHS import HExpandWestLHS
        from HExpandWestNAC2 import HExpandWestNAC2
        lhs = HExpandWestLHS()
        return HExpandWestLHS().eval_x2(attr_value, this) and HExpandWestNAC2(lhs).eval_x2(attr_value, this)


    def eval_y2(self, attr_value, this):
        from HExpandWestLHS import HExpandWestLHS
        from HExpandWestNAC2 import HExpandWestNAC2
        lhs = HExpandWestLHS()
        return HExpandWestLHS().eval_y2(attr_value, this) and HExpandWestNAC2(lhs).eval_y2(attr_value, this)


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        return True

