

from core.himesis import Himesis, HimesisPreConditionPattern
import cPickle as pickle
from uuid import UUID

class HGrowRoadNAC1Bridge(HimesisPreConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HGrowRoadNAC1Bridge.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HGrowRoadNAC1Bridge, self).__init__(name='HGrowRoadNAC1Bridge', num_nodes=2, edges=[])
        
        # Add the edges
        self.add_edges([])
        # Set the graph attributes
        self["GUID__"] = UUID('9b02ff8e-459c-436a-ad37-0b49175de0cd')
        
        # Set the node attributes
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["mm__"] = """MT_pre__Intersection"""
        self.vs[0]["MT_label__"] = """4"""
        self.vs[0]["MT_pre__x"] = """from HGrowRoadNAC1 import HGrowRoadNAC1
from HGrowRoadLHS import HGrowRoadLHS
lhs = HGrowRoadLHS()
return HGrowRoadNAC1(lhs).eval_x4(attr_value, this) and HGrowRoadLHS().eval_x4(attr_value, this)"""
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_pre__y"] = """from HGrowRoadNAC1 import HGrowRoadNAC1
from HGrowRoadLHS import HGrowRoadLHS
lhs = HGrowRoadLHS()
return HGrowRoadNAC1(lhs).eval_y4(attr_value, this) and HGrowRoadLHS().eval_y4(attr_value, this)"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('9fbad61d-1786-4f15-a466-4b2895510093')
        self.vs[1]["MT_subtypeMatching__"] = False
        self.vs[1]["mm__"] = """MT_pre__Intersection"""
        self.vs[1]["MT_label__"] = """2"""
        self.vs[1]["MT_pre__x"] = """from HGrowRoadNAC1 import HGrowRoadNAC1
from HGrowRoadLHS import HGrowRoadLHS
lhs = HGrowRoadLHS()
return HGrowRoadNAC1(lhs).eval_x2(attr_value, this) and HGrowRoadLHS().eval_x2(attr_value, this)"""
        self.vs[1]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[1]["MT_pre__y"] = """from HGrowRoadNAC1 import HGrowRoadNAC1
from HGrowRoadLHS import HGrowRoadLHS
lhs = HGrowRoadLHS()
return HGrowRoadNAC1(lhs).eval_y2(attr_value, this) and HGrowRoadLHS().eval_y2(attr_value, this)"""
        self.vs[1]["MT_dirty__"] = False
        self.vs[1]["GUID__"] = UUID('161b1f61-4725-42de-9ffe-83c36d381b08')

    def eval_x4(self, attr_value, this):
        from HGrowRoadNAC1 import HGrowRoadNAC1
        from HGrowRoadLHS import HGrowRoadLHS
        lhs = HGrowRoadLHS()
        return HGrowRoadNAC1(lhs).eval_x4(attr_value, this) and HGrowRoadLHS().eval_x4(attr_value, this)


    def eval_y4(self, attr_value, this):
        from HGrowRoadNAC1 import HGrowRoadNAC1
        from HGrowRoadLHS import HGrowRoadLHS
        lhs = HGrowRoadLHS()
        return HGrowRoadNAC1(lhs).eval_y4(attr_value, this) and HGrowRoadLHS().eval_y4(attr_value, this)


    def eval_x2(self, attr_value, this):
        from HGrowRoadNAC1 import HGrowRoadNAC1
        from HGrowRoadLHS import HGrowRoadLHS
        lhs = HGrowRoadLHS()
        return HGrowRoadNAC1(lhs).eval_x2(attr_value, this) and HGrowRoadLHS().eval_x2(attr_value, this)


    def eval_y2(self, attr_value, this):
        from HGrowRoadNAC1 import HGrowRoadNAC1
        from HGrowRoadLHS import HGrowRoadLHS
        lhs = HGrowRoadLHS()
        return HGrowRoadNAC1(lhs).eval_y2(attr_value, this) and HGrowRoadLHS().eval_y2(attr_value, this)


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        return True

