

from core.himesis import Himesis, HimesisPreConditionPattern
import cPickle as pickle
from uuid import UUID

class HGrowRoadNAC2Bridge(HimesisPreConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HGrowRoadNAC2Bridge.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HGrowRoadNAC2Bridge, self).__init__(name='HGrowRoadNAC2Bridge', num_nodes=2, edges=[])
        
        # Add the edges
        self.add_edges([])
        # Set the graph attributes
        self["GUID__"] = UUID('c448012d-23a6-4e00-9581-3d5fb15c471b')
        
        # Set the node attributes
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["mm__"] = """MT_pre__Intersection"""
        self.vs[0]["MT_label__"] = """4"""
        self.vs[0]["MT_pre__x"] = """from HGrowRoadNAC2 import HGrowRoadNAC2
from HGrowRoadLHS import HGrowRoadLHS
lhs = HGrowRoadLHS()
return HGrowRoadNAC2(lhs).eval_x4(attr_value, this) and HGrowRoadLHS().eval_x4(attr_value, this)"""
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_pre__y"] = """from HGrowRoadNAC2 import HGrowRoadNAC2
from HGrowRoadLHS import HGrowRoadLHS
lhs = HGrowRoadLHS()
return HGrowRoadNAC2(lhs).eval_y4(attr_value, this) and HGrowRoadLHS().eval_y4(attr_value, this)"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('4b723296-ff19-4918-a6b7-161f92de630c')
        self.vs[1]["MT_subtypeMatching__"] = False
        self.vs[1]["mm__"] = """MT_pre__Intersection"""
        self.vs[1]["MT_label__"] = """2"""
        self.vs[1]["MT_pre__x"] = """from HGrowRoadNAC2 import HGrowRoadNAC2
from HGrowRoadLHS import HGrowRoadLHS
lhs = HGrowRoadLHS()
return HGrowRoadNAC2(lhs).eval_x2(attr_value, this) and HGrowRoadLHS().eval_x2(attr_value, this)"""
        self.vs[1]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[1]["MT_pre__y"] = """from HGrowRoadNAC2 import HGrowRoadNAC2
from HGrowRoadLHS import HGrowRoadLHS
lhs = HGrowRoadLHS()
return HGrowRoadNAC2(lhs).eval_y2(attr_value, this) and HGrowRoadLHS().eval_y2(attr_value, this)"""
        self.vs[1]["MT_dirty__"] = False
        self.vs[1]["GUID__"] = UUID('f58a7bf5-a399-4700-a664-74620c2e3c85')

    def eval_x4(self, attr_value, this):
        from HGrowRoadNAC2 import HGrowRoadNAC2
        from HGrowRoadLHS import HGrowRoadLHS
        lhs = HGrowRoadLHS()
        return HGrowRoadNAC2(lhs).eval_x4(attr_value, this) and HGrowRoadLHS().eval_x4(attr_value, this)


    def eval_y4(self, attr_value, this):
        from HGrowRoadNAC2 import HGrowRoadNAC2
        from HGrowRoadLHS import HGrowRoadLHS
        lhs = HGrowRoadLHS()
        return HGrowRoadNAC2(lhs).eval_y4(attr_value, this) and HGrowRoadLHS().eval_y4(attr_value, this)


    def eval_x2(self, attr_value, this):
        from HGrowRoadNAC2 import HGrowRoadNAC2
        from HGrowRoadLHS import HGrowRoadLHS
        lhs = HGrowRoadLHS()
        return HGrowRoadNAC2(lhs).eval_x2(attr_value, this) and HGrowRoadLHS().eval_x2(attr_value, this)


    def eval_y2(self, attr_value, this):
        from HGrowRoadNAC2 import HGrowRoadNAC2
        from HGrowRoadLHS import HGrowRoadLHS
        lhs = HGrowRoadLHS()
        return HGrowRoadNAC2(lhs).eval_y2(attr_value, this) and HGrowRoadLHS().eval_y2(attr_value, this)


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        return True

