

from core.himesis import Himesis, HimesisPreConditionPattern
import cPickle as pickle
from uuid import UUID

class HGrowRoadNAC4Bridge(HimesisPreConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HGrowRoadNAC4Bridge.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HGrowRoadNAC4Bridge, self).__init__(name='HGrowRoadNAC4Bridge', num_nodes=2, edges=[])
        
        # Add the edges
        self.add_edges([])
        # Set the graph attributes
        self["GUID__"] = UUID('e8a143ea-6735-497d-b697-b45cd9704f18')
        
        # Set the node attributes
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["mm__"] = """MT_pre__Intersection"""
        self.vs[0]["MT_label__"] = """2"""
        self.vs[0]["MT_pre__x"] = """from HGrowRoadNAC4 import HGrowRoadNAC4
from HGrowRoadLHS import HGrowRoadLHS
lhs = HGrowRoadLHS()
return HGrowRoadNAC4(lhs).eval_x2(attr_value, this) and HGrowRoadLHS().eval_x2(attr_value, this)"""
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_pre__y"] = """from HGrowRoadNAC4 import HGrowRoadNAC4
from HGrowRoadLHS import HGrowRoadLHS
lhs = HGrowRoadLHS()
return HGrowRoadNAC4(lhs).eval_y2(attr_value, this) and HGrowRoadLHS().eval_y2(attr_value, this)"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('cae282b4-4871-46a4-9a2a-69ad3d21a84f')
        self.vs[1]["MT_subtypeMatching__"] = False
        self.vs[1]["mm__"] = """MT_pre__Intersection"""
        self.vs[1]["MT_label__"] = """4"""
        self.vs[1]["MT_pre__x"] = """from HGrowRoadNAC4 import HGrowRoadNAC4
from HGrowRoadLHS import HGrowRoadLHS
lhs = HGrowRoadLHS()
return HGrowRoadNAC4(lhs).eval_x4(attr_value, this) and HGrowRoadLHS().eval_x4(attr_value, this)"""
        self.vs[1]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[1]["MT_pre__y"] = """from HGrowRoadNAC4 import HGrowRoadNAC4
from HGrowRoadLHS import HGrowRoadLHS
lhs = HGrowRoadLHS()
return HGrowRoadNAC4(lhs).eval_y4(attr_value, this) and HGrowRoadLHS().eval_y4(attr_value, this)"""
        self.vs[1]["MT_dirty__"] = False
        self.vs[1]["GUID__"] = UUID('3adac259-059f-46fc-bf2d-967314973c99')

    def eval_x2(self, attr_value, this):
        from HGrowRoadNAC4 import HGrowRoadNAC4
        from HGrowRoadLHS import HGrowRoadLHS
        lhs = HGrowRoadLHS()
        return HGrowRoadNAC4(lhs).eval_x2(attr_value, this) and HGrowRoadLHS().eval_x2(attr_value, this)


    def eval_y2(self, attr_value, this):
        from HGrowRoadNAC4 import HGrowRoadNAC4
        from HGrowRoadLHS import HGrowRoadLHS
        lhs = HGrowRoadLHS()
        return HGrowRoadNAC4(lhs).eval_y2(attr_value, this) and HGrowRoadLHS().eval_y2(attr_value, this)


    def eval_x4(self, attr_value, this):
        from HGrowRoadNAC4 import HGrowRoadNAC4
        from HGrowRoadLHS import HGrowRoadLHS
        lhs = HGrowRoadLHS()
        return HGrowRoadNAC4(lhs).eval_x4(attr_value, this) and HGrowRoadLHS().eval_x4(attr_value, this)


    def eval_y4(self, attr_value, this):
        from HGrowRoadNAC4 import HGrowRoadNAC4
        from HGrowRoadLHS import HGrowRoadLHS
        lhs = HGrowRoadLHS()
        return HGrowRoadNAC4(lhs).eval_y4(attr_value, this) and HGrowRoadLHS().eval_y4(attr_value, this)


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        return True

