

from core.himesis import Himesis, HimesisPreConditionPattern
import cPickle as pickle
from uuid import UUID

class HTestNAC0Bridge(HimesisPreConditionPattern):
    def __init__(self):
        """
        Creates the himesis graph representing the AToM3 model HTestNAC0Bridge.
        """
        # Flag this instance as compiled now
        self.is_compiled = True
        
        super(HTestNAC0Bridge, self).__init__(name='HTestNAC0Bridge', num_nodes=1, edges=[])
        
        # Add the edges
        self.add_edges([])
        # Set the graph attributes
        self["GUID__"] = UUID('24c4e050-8ce9-49f6-8c49-dd2ea323951a')
        
        # Set the node attributes
        self.vs[0]["MT_subtypeMatching__"] = False
        self.vs[0]["mm__"] = """MT_pre__Intersection"""
        self.vs[0]["MT_label__"] = """2"""
        self.vs[0]["MT_pre__x"] = """from HTestNAC0 import HTestNAC0
from HTestLHS import HTestLHS
lhs = HTestLHS()
return HTestNAC0(lhs).eval_x2(attr_value, this) and HTestLHS().eval_x2(attr_value, this)"""
        self.vs[0]["MT_subtypes__"] = pickle.loads("""(lp1
.""")
        self.vs[0]["MT_pre__y"] = """from HTestNAC0 import HTestNAC0
from HTestLHS import HTestLHS
lhs = HTestLHS()
return HTestNAC0(lhs).eval_y2(attr_value, this) and HTestLHS().eval_y2(attr_value, this)"""
        self.vs[0]["MT_dirty__"] = False
        self.vs[0]["GUID__"] = UUID('42e82dda-5a69-4c77-a9a6-ca20c51c1c1a')

    def eval_x2(self, attr_value, this):
        from HTestNAC0 import HTestNAC0
        from HTestLHS import HTestLHS
        lhs = HTestLHS()
        return HTestNAC0(lhs).eval_x2(attr_value, this) and HTestLHS().eval_x2(attr_value, this)


    def eval_y2(self, attr_value, this):
        from HTestNAC0 import HTestNAC0
        from HTestLHS import HTestLHS
        lhs = HTestLHS()
        return HTestNAC0(lhs).eval_y2(attr_value, this) and HTestLHS().eval_y2(attr_value, this)


    def constraint(self, PreNode, graph):
        """
            Executable constraint code. 
            @param PreNode: Function taking an integer as parameter
                            and returns the node corresponding to that label.
        """
        return True

